#<profile4xi profile = "02" />
# =================================================================================================
#<program4xi program = "_mainprocess4xi.py">
#<abstract4xi abstract = "provides _MainProcess4Xi class"/>
#<refer4xi reference = "process.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ '_MainProcess4Xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi   

import signal
import itertools
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import Process
except:
    print("_mainprocess4xi.py *** failed in from multiprocessing.process import Process ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from process4xi import Process4Xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi 
#"
#/>


  
# =================================================================================================
#<class4xi class = "_MainProcess4Xi" base = "Process4Xi" child = "None" synopsis = "creates object representing the main process" usage = "
# 
# Usage in Dragon4Xi
#   current_process4xi.py:
#       _current_process = _MainProcess4Xi(), where _MainProcess4Xi is embedded !
#
#   process.py
#       _MainProcess(Process) 
#
#       _current_process = _MainProcess()
#       del _MainProcess
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class _MainProcess4Xi(Process4Xi):
    '''
    creates object representing the main process
    '''

    # ---------------------------------------------------------------------------------------------
    # Public API of this class 
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense',
                 'reason',
                 'ace')          
    #"
    #/>
                                            

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-MainProcess4Xi" usage = "initializes MainProcess4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self):
        '''
        initializes MainProcess4Xi
        '''
            
        # -----------------------------------------------------------------------------------------
        # (Step 1/11)
        # -----------------------------------------------------------------------------------------
        class2print = "MainProcess4Xi"
        method2print = "__init__"
        
        message2print = "{(Step 1/11a) started" + "; init-of-MainProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{(Step 1/11b) borning" + "; mainprocess2xi-of-MainProcess4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
                          
        # -----------------------------------------------------------------------------------------    
        # (Step 2/11) 
        # -----------------------------------------------------------------------------------------  
        self._identity = ()
        
        message2print = "{ (Step 2/11) set" + "; identity-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._identity)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
     
                         
        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/11) 
        # -----------------------------------------------------------------------------------------          
        self._daemonic = False
        
        message2print = "{ (Step 3/11) set" + "; daemonic-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._daemonic)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
             
            
            
        # -----------------------------------------------------------------------------------------    
        # (Step 4/11) 
        # -----------------------------------------------------------------------------------------          
        self._name = '_MainProcess4Xi'
        
        message2print = "{ (Step 4/11) set" + "; name-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
             
        
    
        # -----------------------------------------------------------------------------------------    
        # (Step 5/11) 
        # -----------------------------------------------------------------------------------------          
        self._parent_pid = None
        
        message2print = "{ (Step 5/11) set" + "; parent_pid-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._parent_pid)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
       
             
        
         
        # -----------------------------------------------------------------------------------------    
        # (Step 6/11) 
        # -----------------------------------------------------------------------------------------          
        self._popen = None
        
        message2print = "{ (Step 6/11) set" + "; popen-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
              
        
         
        # -----------------------------------------------------------------------------------------    
        # (Step 7/11) 
        # -----------------------------------------------------------------------------------------          
        self._counter = itertools.count(1)
        
        message2print = "{ (Step 7/11) set" + "; counter-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._counter)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
              
          
         
        # -----------------------------------------------------------------------------------------    
        # (Step 8/11) 
        # -----------------------------------------------------------------------------------------          
        self._children = set()
        
        message2print = "{ (Step 8/11) set" + "; children-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._children)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
              
          
         
        # -----------------------------------------------------------------------------------------    
        # (Step 9/11) 
        # -----------------------------------------------------------------------------------------          
        self._authkey = os.urandom(32)
        
        message2print = "{ (Step 9/11) set" + "; authkey-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._authkey)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
              
    
        
        # -----------------------------------------------------------------------------------------    
        # (Step 10/11) 
        # -----------------------------------------------------------------------------------------          
        self._tempdir = None
        
        message2print = "{ (Step 10/11) set" + "; tempdir-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._tempdir)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
      
        
     
        # -----------------------------------------------------------------------------------------    
        # (Step 11/11)
        # -----------------------------------------------------------------------------------------                   
        message2print = "{(Step 11/11) activated" + "; mainprocess2xi-of-MainProcess4X-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    #</methodize4xi>                 
                 
                
        
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-MainProcess4Xi" usage = "senses MainProcess4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses MainProcess4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        class2print = 'MainProcess4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-MainProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; MainProcess4Xi-sensing-by-sense-of-MainProcess4Xi: " + str(MainProcess4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                       
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-MainProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
                
            kb2xi['identity-of-mainprocess2xi'] = self._identity 
            kb2xi['daemonic-of-mainprocess2xi'] = self._daemonic         
            kb2xi['name-of-mainprocess2xi'] = self._name 
            kb2xi['parent_pid-of-mainprocess2xi'] = self._parent_pid              
            kb2xi['popen-of-mainprocess2xi'] = self._popen 
            kb2xi['counter-of-mainprocess2xi'] = self._counter         
            kb2xi['children-of-mainprocess2xi'] = self._children 
            kb2xi['authkey-of-mainprocess2xi'] = self._authkey 
            kb2xi['tempdir-of-mainprocess2xi'] = self._tempdir 
                            
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-MainProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
       
      
        message2print = "{sensed" + "; MainProcess4Xi-sensed-by-sense-of-MainProcess4Xi: " + str(MainProcess4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-MainProcess4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                              
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-MainProcess4Xi" usage = "reasons MainProcess4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons MainProcess4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------

        class2print = 'MainProcess4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-MainProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; MainProcess4Xi-reasoning-by-reason-of-MainProcess4Xi: " + str(MainProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-MainProcess4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; MainProcess4Xi-reasoned-by-reason-of-MainProcess4Xi: " + str(MainProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-MainProcess4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-MainProcess4Xi" usage = "aces MainProcess4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces MainProcess4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
    
        class2print = 'MainProcess4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-MainProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
           
         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; MainProcess4Xi-acing-by-ace-of-MainProcess4Xi: " + str(MainProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                     
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-MainProcess4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; MainProcess4Xi-aced-by-ace-of-MainProcess4Xi: " + str(MainProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-MainProcess4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                    
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_mainprocess4xi.txt
#   sense-test-mainprocess4xi.xml
#   reason-test-mainprocess4xi.xml
#   ace-test-mainprocess4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _mainprocess4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
